#include "config.h"
#include "env.h"
#include <stdlib.h>

/*
"If you want to generate a random integer between 1
              and 10, you should always do it by

                     j=1+(int) (10.0*rand()/(RAND_MAX+1.0));

              and never by anything resembling

                     j=1+((int) (1000000.0*rand()) % 10);

              (which uses lower-order bits)."
*/

void build_simulation (void)
{
   int x,y;
   srandom (time (NULL)); // true random
   for (x=0;x<MAXX;x++)
      for (y=0;y<MAXY;y++)
         if (random() <= RAND_MAX/2) initialize (x,y,WALL,0);
         else initialize (x,y,QUIESCENT,0);
}
