#include "config.h"
#include "env.h"

static int get_status (char c)
{
   switch (c) {
      case '0': return TOP;
      case '1': return RIGHT;
      case '2': return BOTTOM;
      case '3': return LEFT;
      case '9': return WALL;
	 // go gene
      case 'a': return TOP;
      case 'b': return RIGHT;
      case 'c': return BOTTOM;
      case 'd': return LEFT;	 
	 // invclk gene
      case 'e': return TOP;
      case 'f': return RIGHT;
      case 'g': return BOTTOM;
      case 'h': return LEFT;
	 // clk gene
      case 'i': return TOP;
      case 'j': return RIGHT;
      case 'k': return BOTTOM;
      case 'l': return LEFT;	 
   }
   printf ("error: bad status %c\n",c);
   exit (-1);
   return -1;
}

static int get_state (char c)
{
   switch (c) {
      case '0': 
      case '1': 
      case '2': 
      case '3': 
      case '9': return BASIC;
	 // go gene
      case 'a': return GROW_GENE;
      case 'b': return GROW_GENE;
      case 'c': return GROW_GENE;
      case 'd': return GROW_GENE;	 
	 // invclk gene
      case 'e': return INVCLK_GENE;
      case 'f': return INVCLK_GENE;
      case 'g': return INVCLK_GENE;
      case 'h': return INVCLK_GENE;
	 // clk gene
      case 'i': return CLK_GENE;
      case 'j': return CLK_GENE;
      case 'k': return CLK_GENE;
      case 'l': return CLK_GENE;	 
   }
   printf ("error: bad state  %c\n",c);
   exit (-1);   return -1;
}

/*****************************************/
void build_loop (int size,char **loop,int x,int y)
{
   int i,n;
   char *line;
   for (n = 0; n < size; n++) {
      line = loop[n];
      for (i = 0; i < strlen (line); i++) {
	 if (line[i] == ' ') continue;
	 initialize (x+i,y+n,get_status (line[i]),get_state (line[i]));
      }
   }
}
