#include "config.h"

#ifdef ANIM
#include <stdio.h>
#include "mysprintf.h"

void init_image_saving (void)
{
    system ("rm -rf anim_dir anim.bmp");
    system ("mkdir anim_dir");
}

void save_as_gif (void)
{
   static int n = 0, skipped = 0;
   char *bmp, *gif;
   if (n++ > ANIM) return;
   if (skipped++ < ANIM_SKIP) return;
   bmp = mysprintf ("%06d.bmp",n);
   gif = mysprintf ("%06d.gif",n);
   if (save_display (bmp) != 0) return;
   system (mysprintf ("convert %s anim_dir/%s",bmp,gif));
   system (mysprintf ("rm -rf %s",bmp));
   skipped = 0;
}

void end_image_saving (void)
{
    system ("convert anim_dir/*.gif anim_dir/anim.gif");    
}
#endif
